#ifndef FLOAT_SSE_H
#define FLOAT_SSE_H
//   
void (*subSSEasm)(float*result,float*rigth,float*left);
void (*addSSEasm)(float*result,float*rigth,float*left);
void (*mulSSEasm)(float*result,float*rigth,float*left);
void (*divSSEasm)(float*result,float*rigth,float*left);

/*    .
  SSE  4-  .
 SSE    32- . */
class FLOAT_SSE{
    public:
        float flVec[4];
        //  ,  .
        FLOAT_SSE();
        // .
        FLOAT_SSE(const FLOAT_SSE &value);
        // -  .
        FLOAT_SSE(float value);
        // .
        FLOAT_SSE & operator =(const FLOAT_SSE &value);
        FLOAT_SSE & operator =(const float &value);
        //   .
        float toFloat(const FLOAT_SSE value);
};

FLOAT_SSE::FLOAT_SSE(){//  ,  .
    flVec[0] = 0.0;
    flVec[1] = 0.0;
    flVec[2] = 0.0;
    flVec[3] = 0.0;
}
FLOAT_SSE::FLOAT_SSE(const FLOAT_SSE &value){// .
    flVec[0] = value.flVec[0];
    flVec[1] = value.flVec[0];
    flVec[2] = value.flVec[0];
    flVec[3] = value.flVec[0];
}
FLOAT_SSE::FLOAT_SSE(float value){// -  .
    flVec[0] = value;
    flVec[1] = value;
    flVec[2] = value;
    flVec[3] = value;
}

FLOAT_SSE & FLOAT_SSE::operator =(const FLOAT_SSE &value){// .
    flVec[0] = value.flVec[0];
    flVec[1] = value.flVec[0];
    flVec[2] = value.flVec[0];
    flVec[3] = value.flVec[0];
    return(*this);
}
FLOAT_SSE & FLOAT_SSE::operator =(const float &value){// .
    flVec[0] = value;
    flVec[1] = value;
    flVec[2] = value;
    flVec[3] = value;
    return(*this);
}
// 
FLOAT_SSE operator +(FLOAT_SSE left, FLOAT_SSE rigth);
// 
FLOAT_SSE operator -(FLOAT_SSE left, FLOAT_SSE rigth);
// 
FLOAT_SSE operator *(FLOAT_SSE left, FLOAT_SSE rigth);
// 
FLOAT_SSE operator /(FLOAT_SSE left, FLOAT_SSE rigth);
//  (  -1)
FLOAT_SSE operator -(FLOAT_SSE value);
// 
        //
bool operator ==(FLOAT_SSE left, FLOAT_SSE rigth);
        // 
bool operator !=(FLOAT_SSE left, FLOAT_SSE rigth);
        //
bool operator >(FLOAT_SSE left, FLOAT_SSE rigth);
        //
bool operator <(FLOAT_SSE left, FLOAT_SSE rigth);
        //  
bool operator >=(FLOAT_SSE left, FLOAT_SSE rigth);
        //  
bool operator <=(FLOAT_SSE left, FLOAT_SSE rigth);

FLOAT_SSE::FLOAT_SSE operator +(FLOAT_SSE left, FLOAT_SSE rigth){// 
    FLOAT_SSE result;

    addSSEasm(result.flVec, rigth.flVec, left.flVec);
    return(result);
}
FLOAT_SSE::FLOAT_SSE operator -(FLOAT_SSE left, FLOAT_SSE rigth){// 
    FLOAT_SSE result;

    subSSEasm(result.flVec, rigth.flVec, left.flVec);
    return(result);
}
FLOAT_SSE::FLOAT_SSE operator *(FLOAT_SSE left, FLOAT_SSE rigth){// 
    FLOAT_SSE result;

    mulSSEasm(result.flVec, rigth.flVec, left.flVec);
    return(result);
}
FLOAT_SSE::FLOAT_SSE operator /(FLOAT_SSE left, FLOAT_SSE rigth){// 
    FLOAT_SSE result;

    divSSEasm(result.flVec, rigth.flVec, left.flVec);
    return(result);
}
FLOAT_SSE::FLOAT_SSE operator -(FLOAT_SSE value){//  (  -1)
    value.flVec[0] = -value.flVec[0];
    value.flVec[1] = -value.flVec[0];
    value.flVec[2] = -value.flVec[0];
    value.flVec[3] = -value.flVec[0];
    return(value);
}
bool operator ==(FLOAT_SSE left, FLOAT_SSE rigth){//
    if(left.flVec[0] == rigth.flVec[0])
        return(true);
    else
        return(false);
}
bool operator !=(FLOAT_SSE left, FLOAT_SSE rigth){// 
    if(left.flVec[0] != rigth.flVec[0])
        return(true);
    else
        return(false);
}
bool operator >(FLOAT_SSE left, FLOAT_SSE rigth){//
    if(left.flVec[0] > rigth.flVec[0])
        return(true);
    else
        return(false);
}
bool operator <(FLOAT_SSE left, FLOAT_SSE rigth){//
    if(left.flVec[0] < rigth.flVec[0])
        return(true);
    else
        return(false);
}
bool operator >=(FLOAT_SSE left, FLOAT_SSE rigth){//  
    if(left.flVec[0] >= rigth.flVec[0])
        return(true);
    else
        return(false);
}
bool operator <=(FLOAT_SSE left, FLOAT_SSE rigth){//  
    if(left.flVec[0] <= rigth.flVec[0])
        return(true);
    else
        return(false);
}

//
FLOAT_SSE abs(FLOAT_SSE value){// 
    if(value.flVec[0] < 0.0)
    {
        value.flVec[0] = -value.flVec[0];
        value.flVec[1] = -value.flVec[0];
        value.flVec[2] = -value.flVec[0];
        value.flVec[3] = -value.flVec[0];
    }
    return (value);
}
float toFloat(const FLOAT_SSE value){//   .
    return(value.flVec[0]);
}

#endif // FLOAT_SSE_H
