#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include"float_sse.h"
#include<QLibrary>

void print(FLOAT_SSE **a,int n)
{// 
    int i, j;

    printf("\n");
    for(i = 0; i < n; i++)
    {
        for( j = 0; j < n; j++)
            printf("%.3f\t",toFloat(a[i][j]));
        printf("\n");
    }
    printf("\n");
    return;
}

void inv(FLOAT_SSE **obr,int n)
{// 
    int k, i, j;
    FLOAT_SSE **b, one(1.0);

    b=new FLOAT_SSE *[n];

    for(i = 0; i < n; i++)
    {
        b[i] = new FLOAT_SSE[n];
        for(j = 0; j < n; j++)
            b[i][j] = 0;
    }

    for(k = 0; k < n; k++)
    {
        for(i = 0; i < n; i++)
        {
            for(j = 0; j < n; j++)
            {
                if(i==k && j==k)
                {
                    b[i][j] = one / obr[i][j];
                }
                if(i==k && j!=k)
                {
                    b[i][j] = -obr[i][j] / obr[k][k];
                }
                if(i!=k && j==k)
                {
                    b[i][j] = obr[i][k] / obr[k][k];
                }
                if(i!=k && j!=k)
                {
                    b[i][j] = obr[i][j] - obr[k][j] * obr[i][k] / obr[k][k];
                }
            }
        }

        for(i = 0; i < n; i++)
        {
            for(j=0;j<n;j++)
            {
                obr[i][j] = b[i][j];
            }
        }
    }

    for(i=0;i<n;i++)
    {
        delete [] b[i];
    }
    delete [] b;
}

int main(int argc, char* argv[])
{
    QLibrary myLib("arithmeticSSE");	// 
    myLib.load();						// arithmeticSSE
    addSSEasm = (void (*)(float*,float*,float*))myLib.resolve("addSSEasm");
    subSSEasm = (void (*)(float*,float*,float*))myLib.resolve("subSSEasm");
    mulSSEasm = (void (*)(float*,float*,float*))myLib.resolve("mulSSEasm");
    divSSEasm = (void (*)(float*,float*,float*))myLib.resolve("divSSEasm");
	//   
    FLOAT_SSE **a, **b, sum, sum1;
    int n, i, j, ki;
    float s=0, tm;
    char tmp[255];
    FILE *in, *out;

    for (n = 4; n < 15; n++)
    {
        a = new FLOAT_SSE* [n];
        b = new FLOAT_SSE* [n];
        sprintf(tmp, "%d.mx", n);
        in=fopen(tmp, "rt");	//    
        for(i = 0; i < n; i++)
        {
            a[i] = new FLOAT_SSE[n];
            b[i] = new FLOAT_SSE[n];
            for(j = 0; j < n; j++)
            {
                fscanf(in, "%f", &tm);
                b[i][j] = tm;
                a[i][j] = tm;	//     
            }
        }
        fclose(in);
        sprintf(tmp, "f32_%d.txt", n);
        out=fopen(tmp, "wt");
        for (ki = 1; ki <= 50; ki++)
        {
            sum = 0.0;
            inv(a, n);
            inv(a, n);	//  

        for(i = 0; i < n; i++)
            {
                for(j = 0; j < n; j++)
                {
                    sum1 = abs(a[i][j]-b[i][j]);
                    sum = sum + sum1;	//  
                }
            }
        s = toFloat(sum);
        sprintf(tmp, "%e", s);
        tmp[1] = ',';
        fprintf(out, "\n%s", tmp);	//   
//        fprintf(out, "\n%e", s);
        }
        fclose(out);
        print(b, n);
        print(a, n);	//      
    }
    return 0;
}
