#include<QLibrary>
#include "tnsfloat.cpp"

void print(TNSFLOAT **a,int n)
{// 
    int i, j;

    printf("\n");
    for(i = 0; i < n; i++)
    {
        for(j = 0; j < n; j++)
            printf("%.3f\t", tnsToFloat(a[i][j]));
        printf("\n");
    }
    printf("\n");
    return;
}

void inv(TNSFLOAT **obr, int n)
{// 
    int k, i, j;
    TNSFLOAT **b, one;

    one = 1.0;
    b = new TNSFLOAT*[n];

    for(i = 0; i < n; i++)
    {
        b[i] = new TNSFLOAT[n];
        for(j = 0; j < n; j++)
            b[i][j] = 0;
    }

    for(k = 0; k < n; k++)
    {
        for(i = 0; i < n; i++)
        {
            for(j = 0; j < n; j++)
            {
                if(i==k && j==k)
                {
                    b[i][j] = one / obr[i][j];
                }
                if(i==k && j!=k)
                {
                    b[i][j] = -obr[i][j] / obr[k][k];
                }
                if(i!=k && j==k)
                {
                    b[i][j] = obr[i][k] / obr[k][k];
                }
                if(i!=k && j!=k)
                {
                    b[i][j] = obr[i][j] - obr[k][j] * obr[i][k] / obr[k][k];
                }
            }
        }

        for(i = 0; i < n; i++)
        {
            for(j = 0; j < n; j++)
            {
                obr[i][j] = b[i][j];
            }
        }
    }
    for(i = 0; i < n; i++)
    {
        delete [] b[i];
    }
    delete [] b;
}

int main(int argc, char *argv[])
{
    QLibrary myLib("tnsFloatDll");	// 
    myLib.load();					// tnsFloatDll

    mul = (void (*)(signed char *exp, signed char *manti, int eSize, int mSize, signed char *leftExpo, signed char *leftMant,
        signed char *rightExpo, signed char *rightMant, signed char *eTmp, signed char *cMul))myLib.resolve("_Z3mulPaS_iiS_S_S_S_S_S_");
    add = (void (*)(signed char *exp, signed char *manti, int eSize, int mSize, signed char *leftExpo, signed char *leftMant,
        signed char *rightExpo, signed char *rightMant, signed char *eTmp))myLib.resolve("_Z3addPaS_iiS_S_S_S_S_");
    inversStr = (void(*)(signed char *value, int size))myLib.resolve("_Z9inversStrPai");
    div = (void (*)(signed char *exp, signed char *manti, int eSize, int mSize, signed char *dividentEx, signed char *dividentMa,
        signed char *measureEx, signed char *measureMa, signed char *quotientLeft, signed char *quotientRight, signed char *curDeduction,
        signed char *eTmp))myLib.resolve("_Z3divPaS_iiS_S_S_S_S_S_S_S_");
	//   
		
    TNSFLOAT **a, **b, sum, sum1;
    int n, i, j, ki;
    float s;
    char tmp[255];
    FILE *in, *out;

    for (n = 4; n < 15; n++)
    {
        a = new TNSFLOAT* [n];
        b = new TNSFLOAT* [n];
        sprintf(tmp, "%d.mx", n);
        in = fopen(tmp, "rt");	//    
        for(i = 0; i < n; i++)
        {
            a[i] = new TNSFLOAT[n];
            b[i] = new TNSFLOAT[n];
            for(j = 0; j < n; j++)
            {
                fscanf(in, "%f", &s);
                a[i][j] = s;
                b[i][j] = a[i][j];	//     
            }
        }
        fclose(in);
        sprintf(tmp, "t15_%d.txt", n);
        out=fopen(tmp, "wt");
        for (ki = 1; ki <= 50; ki++)
        {
            sum = 0;
            inv(a, n);
            inv(a, n);	//  

			for(i = 0; i < n; i++)
            {
                for(j = 0; j < n; j++)
                {
                    sum1 = a[i][j] - b[i][j];
                    sum += abs(sum1);	//  
                }
            }
        s = tnsToFloat(sum);
        sprintf(tmp, "%e", s);
        tmp[1] = ',';
        fprintf(out, "\n%s", tmp);	//   
//        fprintf(out, "\n%e", s);
        }
        fclose(out);
/*        for(i = 0; i < n; i++)
            delete [] b[i];
        delete [] b;

        for(i = 0; i < n; i++)
            delete [] a[i];
        delete [] a;*/
        print(b, n);
        print(a, n);	//      
    }
//    getchar();
    return 0;
}
