/*         
 ..,  ..
    
tnsfloat@mail.ru
 0.1

     .
        
,  ,     .
*/
#include "tnsfloat.h"

TNSFLOAT operator /=(TNSFLOAT &left, const TNSFLOAT &right)/* 
 /=.*/
{
    left = left / right;
    return (left);
}

TNSFLOAT operator *=(TNSFLOAT &left, const TNSFLOAT &right)/* 
 *=.*/
{
    left = left * right;
    return (left);
}

TNSFLOAT operator -=(TNSFLOAT &left, const TNSFLOAT &right)/* 
 -=.*/
{
    left = left - right;
    return (left);
}

TNSFLOAT operator +=(TNSFLOAT &left, const TNSFLOAT &right)/* 
 +=.*/
{
    left = left + right;
    return (left);
}

bool operator >= (const TNSFLOAT &left, const TNSFLOAT &right)/* 
    2- TNSFLOAT .
 2- TNSFLOAT ,        
.
  .   inversStr,   add.
    c 1.*/
{
    TNSFLOAT result;
    signed char lExpo[expoSIZE+1], lMant[mantSIZE+1], rExpo[expoSIZE+1], rMant[mantSIZE+1], eTmp[expoSIZE+1];
    int i;

    for(i = 0; i <= expoSIZE; i++)
    {
        lExpo[i] = left.expo[i];
        rExpo[i] = right.expo[i];
        eTmp[i] = 0;
    }
    for(i = 0; i <= mantSIZE; i++)
    {
        lMant[i] = left.mant[i];
        rMant[i] = right.mant[i];
    }
    inversStr(rMant, mantSIZE);
    add(result.expo, result.mant, expoSIZE, mantSIZE, lExpo, lMant, rExpo, rMant, eTmp);
    if(result.mant[mantSIZE-1] <= -1)
        return(false);
    return(true);
}

bool operator <= (const TNSFLOAT &left, const TNSFLOAT &right)/* 
    2- TNSFLOAT .
 2- TNSFLOAT ,        
.
  .   inversStr,   add.
    c 1.*/
{
    TNSFLOAT result;
    signed char lExpo[expoSIZE+1], lMant[mantSIZE+1], rExpo[expoSIZE+1], rMant[mantSIZE+1], eTmp[expoSIZE+1];
    int i;

    for(i = 0; i <= expoSIZE; i++)
    {
        lExpo[i] = left.expo[i];
        rExpo[i] = right.expo[i];
        eTmp[i] = 0;
    }
    for(i = 0; i <= mantSIZE; i++)
    {
        lMant[i] = left.mant[i];
        rMant[i] = right.mant[i];
    }
    inversStr(rMant, mantSIZE);
    add(result.expo, result.mant, expoSIZE, mantSIZE, lExpo, lMant, rExpo, rMant, eTmp);
    if(result.mant[mantSIZE-1] >= 1)
        return(false);
    return(true);
}

bool operator < (const TNSFLOAT &left, const TNSFLOAT &right)/* 
  2- TNSFLOAT .
 2- TNSFLOAT ,        
.
  .   inversStr,   add.
    c -1.*/
{
    TNSFLOAT result;
    signed char lExpo[expoSIZE+1], lMant[mantSIZE+1], rExpo[expoSIZE+1], rMant[mantSIZE+1], eTmp[expoSIZE+1];
    int i;

    for(i = 0; i <= expoSIZE; i++)
    {
        lExpo[i] = left.expo[i];
        rExpo[i] = right.expo[i];
        eTmp[i] = 0;
    }
    for(i = 0; i <= mantSIZE; i++)
    {
        lMant[i] = left.mant[i];
        rMant[i] = right.mant[i];
    }
    inversStr(rMant, mantSIZE);
    add(result.expo, result.mant, expoSIZE, mantSIZE, lExpo, lMant, rExpo, rMant, eTmp);
    if(result.mant[mantSIZE-1] == -1)
        return(true);
    return(false);
}

bool operator > (const TNSFLOAT &left, const TNSFLOAT &right)/* 
  2- TNSFLOAT .
 2- TNSFLOAT ,        
.
  .   inversStr,   add.
    c 1.*/
{
    TNSFLOAT result;
    signed char lExpo[expoSIZE+1], lMant[mantSIZE+1], rExpo[expoSIZE+1], rMant[mantSIZE+1], eTmp[expoSIZE+1];
    int i;

    for(i = 0; i <= expoSIZE; i++)
    {
        lExpo[i] = left.expo[i];
        rExpo[i] = right.expo[i];
        eTmp[i] = 0;
    }
    for(i = 0; i <= mantSIZE; i++)
    {
        lMant[i] = left.mant[i];
        rMant[i] = right.mant[i];
    }
    inversStr(rMant, mantSIZE);
    add(result.expo, result.mant, expoSIZE, mantSIZE, lExpo, lMant, rExpo, rMant, eTmp);
    if(result.mant[mantSIZE-1] == 1)
        return(true);
    return(false);
}

bool operator != (const TNSFLOAT &left, const TNSFLOAT &right)/* 
 .
 2- TNSFLOAT ,      ,  .
   .*/
{
    int i;

    for(i = expoSIZE; i >= 0; i--)
        if(left.expo[i] != right.expo[i])
            return(true);
    for(i = mantSIZE ; i >=0 ; i--)
        if(left.mant[i] != right.mant[i])
            return(true);
    return(false);
}

bool operator == (const TNSFLOAT &left, const TNSFLOAT &right)/* 
 .
 2- TNSFLOAT ,      ,  .
   .*/
{
    int i;

    for(i = expoSIZE; i >= 0; i--)
        if(left.expo[i] != right.expo[i])
            return(false);
    for(i = mantSIZE ; i >=0 ; i--)
        if(left.mant[i] != right.mant[i])
            return(false);
    return(true);
}

TNSFLOAT abs(TNSFLOAT &value)
/*   TNSFLOAT .
 TNSFLOAT ,    ,   ,
   inversStr() */

{
    TNSFLOAT result;
    int i;

    for(i = 0; i <= expoSIZE; i++)
        result.expo[i] = value.expo[i];
    for(i = 0; i <= mantSIZE; i++)
        result.mant[i] = value.mant[i];
    if(result.mant[mantSIZE-1] == -1)
        inversStr(result.mant, mantSIZE);
    return(result);
}

TNSFLOAT operator - (const TNSFLOAT &value)
/* , ,   -1.
 TNSFLOAT ,        inversStr()*/

{
    TNSFLOAT result;
    int i;

    for(i = 0; i <= expoSIZE; i++)
        result.expo[i] = value.expo[i];
    for(i = 0; i <= mantSIZE; i++)
        result.mant[i] = value.mant[i];
    inversStr(result.mant, mantSIZE);
    return(result);
}

TNSFLOAT operator * (const TNSFLOAT &left, const TNSFLOAT &right)/* 
2- TNSFLOAT .
 2- TNSFLOAT ,        
.
    .   mul. */
{
    TNSFLOAT result;
    signed char lExpo[expoSIZE+1], lMant[mantSIZE+1], rExpo[expoSIZE+1], rMant[mantSIZE+1],
          eTmp[expoSIZE+1], cMul[mantSIZE+1];
    int i;

    for(i = 0; i <= expoSIZE; i++)
    {
        lExpo[i] = left.expo[i];
        rExpo[i] = right.expo[i];
        eTmp[i] = 0;
    }
    for(i = 0; i <= mantSIZE; i++)
    {
        lMant[i] = left.mant[i];
        rMant[i] = right.mant[i];
        cMul[i] = 0;
    }
    mul(result.expo, result.mant, expoSIZE, mantSIZE, lExpo, lMant, rExpo, rMant, eTmp, cMul);
    return(result);
}

TNSFLOAT operator - (const TNSFLOAT &left, const TNSFLOAT &right)/* 
2- TNSFLOAT .
 2- TNSFLOAT ,        
.
  .   inversStr,   add. */
{
    TNSFLOAT result;
    signed char lExpo[expoSIZE+1], lMant[mantSIZE+1], rExpo[expoSIZE+1], rMant[mantSIZE+1], eTmp[expoSIZE+1];
    int i;

    for(i = 0; i <= expoSIZE; i++)
    {
        lExpo[i] = left.expo[i];
        rExpo[i] = right.expo[i];
        eTmp[i] = 0;
    }
    for(i = 0; i <= mantSIZE; i++)
    {
        lMant[i] = left.mant[i];
        rMant[i] = right.mant[i];
    }
    inversStr(rMant, mantSIZE);
    add(result.expo, result.mant, expoSIZE, mantSIZE, lExpo, lMant, rExpo, rMant, eTmp);
    return(result);
}

TNSFLOAT operator + (const TNSFLOAT &left, const TNSFLOAT &right)/* 
2- TNSFLOAT .
 2- TNSFLOAT ,        
.
  .   add. */
{
    TNSFLOAT result;
    signed char lExpo[expoSIZE+1], lMant[mantSIZE+1], rExpo[expoSIZE+1], rMant[mantSIZE+1], eTmp[expoSIZE+1];
    int i;

    for(i = 0; i <= expoSIZE; i++)
    {
        lExpo[i] = left.expo[i];
        rExpo[i] = right.expo[i];
        eTmp[i] = 0;
    }
    for(i = 0; i <= mantSIZE; i++)
    {
        lMant[i] = left.mant[i];
        rMant[i] = right.mant[i];
    }
    add(result.expo, result.mant, expoSIZE, mantSIZE, lExpo, lMant, rExpo, rMant, eTmp);
    return(result);
}

TNSFLOAT operator / (const TNSFLOAT &left, const TNSFLOAT &right)/* 
.
 2- TNSFLOAT ,        
.
  ,  2-   ,  
 .   div. */
{
    TNSFLOAT result;

    signed char lExpo[expoSIZE+1], lMant[mantSIZE+1], rExpo[expoSIZE+1], rMant[mantSIZE+1], eTmp[expoSIZE+1],
          quotientLeft[mantSIZE+2], quotientRight[mantSIZE+2], curDeduction[mantSIZE+1];
    int i;

    quotientLeft[mantSIZE+1] = 0;
    quotientRight[mantSIZE+1] = 0;
    curDeduction[mantSIZE] = 0;
    for(i = 0; i <= expoSIZE; i++)
    {
        lExpo[i] = left.expo[i];
        rExpo[i] = right.expo[i];
        eTmp[i] = 0;
    }
    for(i = 0; i <= mantSIZE; i++)
    {
        lMant[i] = left.mant[i];
        rMant[i] = right.mant[i];
    }
    div(result.expo, result.mant, expoSIZE, mantSIZE, lExpo, lMant, rExpo, rMant,
        quotientLeft, quotientRight, curDeduction, eTmp);
    return(result);
}

void printTnsFloat(TNSFLOAT value)/*  TNSFLOAT .
  -1   7.*/
{
    int i, ouM[mantSIZE+1], ouE[expoSIZE+1];

    for(i = 0; i <= expoSIZE; i++)
        ouE[i] = 0;
    for(i = 0; i <= mantSIZE; i++)
        ouM[i] = 0;

    printf("0.");
    for(i = mantSIZE-1; i >= 0; i--)
    {
        if(value.mant[i] == -1)
            ouM[i] = 7;
        else ouM[i] = value.mant[i];
        printf("%d",ouM[i]);
    }
    printf(" t");
    for(i = expoSIZE; i >=0 ; i--)
    {
        if(value.expo[i] == -1)
            ouE[i] = 7;
        else ouE[i] = value.expo[i];
        printf("%d",ouE[i]);
    }
}

double tnsToFloat(TNSFLOAT value)/*  TNSFLOAT   double.*/
{
    double p = 3.0, tmp = 0.0;
    int i, s = 0, pp = 1;

    for(int i = 0; i < expoSIZE; i++)
    {
        s += pp * value.expo[i];
        pp *= 3;
    }

    for(i = mantSIZE-1; i >= 0; i--)
    {
      p/=3;
      tmp+= value.mant[i]*p;
    }
    tmp*=pow((double)3., s-1);
    return(tmp);
}

TNSFLOAT &TNSFLOAT::operator = (const double fl)/* double 
 TNSFLOAT .*/
{
    double dec = fl;
    int e = 0, p = 0, i;

    if(dec == 0.0)
    {
        for(i = 0; i <= expoSIZE; i++)
            expo[i] = 0;
        for(i = 0; i <= mantSIZE; i++)
            mant[i] = 0;
        return(*this);
    }
    // 
    while ((dec>0?dec:-dec)>1./2.)
    {
      dec/=3.;
      e++;
    }
    while ((dec>0?dec:-dec)<1./6.)
    {
      dec*=3.;
      e--;
    }

    for(int i = 0; i <= expoSIZE; i++)
    {
        expo[i] = e % 3 + p;
        e /= 3;
        p = 0;
        if(expo[i] == -3)
        { p =-1; expo[i] = 0; }
        if(expo[i] == -2)
        { p =-1; expo[i] = 1; }
        if(expo[i] == 2)
        { p = 1; expo[i] =-1; }
        if(expo[i] == 3)
        { p = 1; expo[i] = 0; }
    }

    // 
    for(int i = mantSIZE-1; i >= 0; i--)
    {
      if ((dec>0?dec:-dec)>=1./6.)
      {
        mant[i] = (dec>0?1:-1);
        dec += (dec>=0?1:-1) * -1./3.;
      }
      else
        mant[i] = 0;
      dec *= 3.;
    }
    return(*this);
}

TNSFLOAT &TNSFLOAT::operator = (const TNSFLOAT &value)/*   
  .*/
{
    int i;

    for(i = 0; i <= expoSIZE; i++)
        expo[i] = value.expo[i];
    for(i = 0; i <= mantSIZE; i++)
        mant[i] = value.mant[i];
    return(*this);
}

TNSFLOAT::~TNSFLOAT()/**/
{
}

TNSFLOAT::TNSFLOAT()/*,    .*/
{
    int i;

    for(i = 0; i <= expoSIZE; i++)
        expo[i] = 0;
    for(i = 0; i <= mantSIZE; i++)
        mant[i] = 0;
}
